package org.mandarax.util;

/*
 * Copyright (C) 1999-2004 <a href="mailto:mandarax@jbdietrich.com">Jens Dietrich</a>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
 


import java.util.*;
import org.apache.commons.collections.Predicate;
import org.apache.commons.collections.iterators.FilterIterator;

/**
 * A filter iterator that identifies objects that are equal (i.e., where 
 * invoking equals invokes true).
 * @author <A HREF="mailto:mandarax@jbdietrich.com">Jens Dietrich</A>
 * @version 3.3.1 <9 August 2004>
 * @since 3.0
 */

public class EqualsFilterIterator extends FilterIterator {
	
	private HashSet doneObjects = new HashSet();
	// filter condition
	class EqualsCondition implements Predicate {
		EqualsCondition() {
			super();
		}
		public boolean evaluate(Object obj) {
			if (doneObjects.contains(obj)) return false;
			else {
				doneObjects.add(obj);
				return true;
			}
		}
	}
	
	/**
	 * Constructor.
	 * @param iterator the wrapped iterator
	 */
	public EqualsFilterIterator(Iterator iterator) {
		super(iterator);
		setPredicate(new EqualsCondition());
	}



}
